#Sistema Solare

from graphics import * #Importiamo la Libreria Grafica
import math

gm = 4 * math.pi * math.pi

def acc(x, y, z):             #Definiamo l'Accelerazione
    r = math.sqrt(x*x+y*y+z*z)
    r3= r*r*r

    return -gm*x/r3, -gm*y/r3,-gm*z/r3

def Ekin(Vx, Vy, Vz):
    return 0.5*(Vx*Vx + Vy*Vy + Vz*Vz)

def Epot(x, y, z):
    r = math.sqrt(x*x+y*y+z*z)
    return -gm/r


def PotEff(Vx,Vy,Vz,x,y,z):
    r = math.sqrt(x*x+y*y+z*z)
    
    Vr = (Vx * x + Vy * y + Vz * z)/r

    Er = 0.5 * Vr * Vr

    return Ekin(Vx,Vy,Vz) - gm/r - Er

       
#def Energia(x,y,z,Vx,Vy,Vz):
#    return .....


Win = GraphWin("Sistema Solare", 1000, 1000) #Definiamo la Finestra
Win.setCoords(-20,-15,10,15)
Win.setBackground("black")

AsseX = Line(Point(-5,0), Point(5,0)) #Definiamo l'AsseX
AsseX.setOutline("white")
AsseX.draw(Win)

AsseY = Line(Point(0,-5), Point(0,5)) #Definiamo l'AsseY
AsseY.setOutline("white")
AsseY.draw(Win)


Win1 = GraphWin("Grafico Energia", 500, 200) #Definiamo la Finestra
Win1.setCoords(-1,-50,10,40)
Win1.setBackground("black")

AsseX = Line(Point(-1,0), Point(40,0)) #Definiamo l'AsseX
AsseX.setOutline("white")
AsseX.draw(Win1)

AsseY = Line(Point(0,-5), Point(0,5)) #Definiamo l'AsseY
AsseY.setOutline("white")
AsseY.draw(Win1)

Win2 = GraphWin("Pot Eff", 500, 200) #Definiamo la Finestra
Win2.setCoords(-0.02,-100,2,0.1)
Win2.setBackground("black")


out = open("traie.dat","w")

for kv in range(0,16):

    # condizioni iniziali

    T = 0
    Tmax = 3
    DT = 0.001

    x = 1
    y = 0.
    z = 0.
    
    VV = 2 * math.pi * (1. + kv /40.)
    
    out.write("\n\n")
    out.write("# " + str(VV) + "\n")

    Vx = 0
    Vy = 1.1*VV
    Vz = 0.
    

####################
    
# Loop sul tempo
    k=0

    psold = 0.

    cc = 0

    while T < Tmax: 

        k+=1
        
#        out.write(str(x) + " " + str(y) + "\n")
    
        x = x + Vx*DT
        y = y + Vy*DT
        z = z + Vz*DT
        
        Ep = Epot(x,y,z)
        
        ax,ay,az = acc(x,y,z)
        
        Vx = Vx + ax*DT
        Vy = Vy + ay*DT
        Vz = Vz + az*DT
        
        Ek = Ekin(Vx,Vy,Vz)
        
        T = T + DT
        


        Etot = Ek + Ep
        PE = PotEff(Vx,Vy,Vz,x,y,z)
        
        r = math.sqrt(x*x+y*y+z*z)

        if k%100 == 0:
            print(T, Ek, Ep, Etot)
        
        ps = Vx * x + Vy * y + Vz * z

        if ps*psold < 0:
            rr = math.sqrt(x*x+y*y+z*z)
            print("r = ", rr, " t = ", T)
            out.write(str(rr) + " " + str(2*T) + "\n")
            if ps<0:
                cc += 1
            T = Tmax

        psold = ps
                
        if k%10 == 0:
        
#        cc = k // 1000

            Win1.plot(T,Ek,"white")
            Win1.plot(T,Ep,"red")
            Win1.plot(T,Etot,"green")

            if cc%2 == 0:
                Win2.plot(r,PE,"yellow")
                Win.plot(x,y,"white")
            else:
                Win2.plot(r,PE,"red")
                Win.plot(x,y,"cyan")
    

out.close()
