#Sistema Solare

from graphics import * #Importiamo la Libreria Grafica
import math

gm = 4 * math.pi * math.pi
m1 = 0.001
m2 = 0.04


def acc(x, y, z):             #Definiamo l'Accelerazione
    r = math.sqrt(x*x+y*y+z*z)
    #r3= r*r*r

    r3 = math.pow(r,3) # una potenza diversa!

    return -gm*x/r3, -gm*y/r3,-gm*z/r3

def Ekin(Vx, Vy, Vz):
    return 0.5*(Vx*Vx + Vy*Vy + Vz*Vz)

def Epot(x, y, z):
    r = math.sqrt(x*x+y*y+z*z)
    return -gm/r


def F12(x1,y1,z1, x2,y2,z2):
    
    # Calcolo il vettore differenza da 1 -> 2

    dx = x2 - x1
    dy = y2 - y1
    dz = z2 - z1

    r12 = math.sqrt( dx*dx + dy*dy + dz*dz )

    r12cub = r12*r12*r12

    # cosi' ottengo la forza che m2 senta da parte di m1
    
    Gm1m2 = gm * m1 * m2

    return -Gm1m2 * dx / r12cub, -Gm1m2 * dy / r12cub, -Gm1m2 * dz / r12cub, 




def PotEff(Vx,Vy,Vz,x,y,z):
    r = math.sqrt(x*x+y*y+z*z)
    
    Vr = (Vx * x + Vy * y + Vz * z)/r

    Er = 0.5 * Vr * Vr

    return Ekin(Vx,Vy,Vz) - gm/r - Er

       
#def Energia(x,y,z,Vx,Vy,Vz):
#    return .....


Win = GraphWin("Sistema Solare", 1000, 1000) #Definiamo la Finestra
Win.setCoords(-10,-10,10,10)
Win.setBackground("black")

AsseX = Line(Point(-5,0), Point(5,0)) #Definiamo l'AsseX
AsseX.setOutline("white")
AsseX.draw(Win)

AsseY = Line(Point(0,-5), Point(0,5)) #Definiamo l'AsseY
AsseY.setOutline("white")
AsseY.draw(Win)


# condizioni iniziali

T = 0
Tmax = 5
DT = 0.001

x1 = 1; y1 = 0.; z1 = 0.
x2 = -2; y2 = 0.; z2 = 0.

V1x = 0; V1y = 2 * math.pi; V1z = 0.
V2x = 0; V2y = -1.414 * math.pi; V2z = 0.

####################

# Loop sul tempo

k = 0 

while T < Tmax: 

    x1 = x1 + V1x*DT; y1 = y1 + V1y*DT; z1 = z1 + V1z*DT
    x2 = x2 + V2x*DT; y2 = y2 + V2y*DT; z2 = z2 + V2z*DT

    a1x,a1y,a1z = acc(x1,y1,z1)
    a2x,a2y,a2z = acc(x2,y2,z2)

    f12x, f12y, f12z =  F12(x1,y1,z1, x2,y2,z2)

    a1x = a1x - f12x / m1; a1y = a1y - f12y / m1; a1z = a1z - f12z / m1
    a2x = a2x + f12x / m2; a2y = a2y + f12y / m2; a2z = a2z + f12z / m2

    V1x = V1x + a1x*DT; V1y = V1y + a1y*DT; V1z = V1z + a1z*DT
    V2x = V2x + a2x*DT; V2y = V2y + a2y*DT; V2z = V2z + a2z*DT
    
    T = T + DT

    if k%5 == 0:
        Win.plot(x1,y1,"white")
        Win.plot(x2,y2,"red")

    k = k + 1

    print(T,x1,y1,x2,y2)
